#ifndef TSOS_DRV_VGA_SCREEN
#define TSOS_DRV_VGA_SCREEN

#define VMEM_ADDRESS 0xb8000
#define MAX_ROWS 25
#define MAX_COLS 80
#define LIGHT_GREY_ON_BLACK 0x07
#define RED_ON_WHITE 0xf4

// VGA I/O ports
#define REG_SCREEN_CTRL 0x3d4
#define REG_SCREEN_DATA 0x3d5

#include "kernel/ktypes.h"
#include "kernel/drivers/ports/ports.h"

// Exposed API
void clear_screen(void);
void kprint_at(char *message, int col, int row);
void kprint(char *message);


#endif